.nolist
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm

I64toDecimalASCII proto :DWORD,:DWORD, :PTR BYTE
I64toDecimalASCII2 proto :DWORD,:DWORD, :PTR BYTE
dq2ascii proto :DWORD, :DWORD

.data?
buffer	byte 100 dup (?)
buff    byte  256 dup (?)

.data
AscBuf  DB      '01234567890123456789',0  ;20 ASCII digits
My64a	QWORD	18067432769859648
.code
start:
	call GetCPUName
	print offset buff, 13, 10
    LoopCount = 1000000
	invoke Sleep, 500
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
	invoke I64toDecimalASCII,4206656,4206652,addr buffer
	counter_end
	print ustr$(eax)," cycles for I64toDecimalASCII", 9
	print offset buffer, 13, 10
	
	LoopCount = 1000000
	invoke Sleep, 500
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
	invoke I64toDecimalASCII2,4206656,4206652,addr buffer
	counter_end
	print ustr$(eax)," cycles for I64toDecimalASCII Modified", 9
	print offset buffer, 13, 10
	
	LoopCount = 1000000
	invoke Sleep, 500
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
    lea edi,buffer
    mov eax,4206656
    mov edx,4206652
	call Asc64
	counter_end
	print ustr$(eax)," cycles for Asc64", 9
	print offset buffer, 13, 10
	
	LoopCount = 1000000
	invoke Sleep, 500
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
    lea edi,buffer
    mov eax,4206656
    mov edx,4206652
	call Asc642
	counter_end
	print ustr$(eax)," cycles for Asc64 Modified", 9
	print offset buffer, 13, 10
	
	LoopCount = 1000000
	invoke Sleep, 500
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
	invoke  dq2ascii,addr My64a,addr buffer
	counter_end
	print ustr$(eax)," cycles for dq2ascii Modified", 9
	print offset buffer, 13, 10
	inkey
	

I64toDecimalASCII PROC lo:DWORD, hi:DWORD, outstr:PTR BYTE

push ebx

mov eax,lo
mov edx,hi

mov ecx,10 ; Base 10 decimal

push 0 ; NUL

divloop:

; edx:eax = edx:eax / 10, ebx = edx:eax % 10

xor ebx,ebx
xchg eax,ebx

xchg eax,edx

div ecx
xchg eax,ebx

div ecx
xchg edx,ebx

add ebx,030h ; convert digit to ASCII
push ebx ; stack

mov ebx,eax ; edx:eax == 0
xor ebx,edx
jnz divloop

mov ebx,outstr ; string, at least 21 chars

unstack:

pop eax ; unstack characters
mov [ebx],al
inc ebx
or eax,eax ; NUL
jnz unstack

pop ebx
ret

I64toDecimalASCII ENDP

I64toDecimalASCII2 PROC lo:DWORD, hi:DWORD, outstr:PTR BYTE

push ebx

mov eax,lo
mov edx,hi

mov ecx,10 ; Base 10 decimal

push 0 ; NUL

divloop:

; edx:eax = edx:eax / 10, ebx = edx:eax % 10

xor ebx,ebx
;xchg eax,ebx
xor     eax,ebx
xor     ebx,eax
xor     eax,ebx

;xchg eax,edx
xor     eax,edx
xor     edx,eax
xor     eax,edx

div ecx
;xchg eax,ebx
xor     eax,ebx
xor     ebx,eax
xor     eax,ebx
div ecx
xchg edx,ebx

add ebx,030h ; convert digit to ASCII
push ebx ; stack

mov ebx,eax ; edx:eax == 0
xor ebx,edx
jnz divloop

mov ebx,outstr ; string, at least 21 chars

unstack:

pop eax ; unstack characters
mov [ebx],al
inc ebx
or eax,eax ; NUL
jnz unstack

pop ebx
ret

I64toDecimalASCII2 ENDP

Asc64   PROC

;Convert 64-bit unsigned integer to ASCII decimal string
;
;Call With: EDX:EAX= QWORD value to convert
;
;  Returns: EDI= Offset into AscBuf of first numchar

        std
        mov     edi,offset AscBuf+18
        mov     ecx,edx
        xchg    eax,esi
        mov     ebx,100

Asc64a: xor     edx,edx
        xchg    eax,ecx
        div     ebx
        xchg    eax,ecx
        xchg    eax,esi
        div     ebx
        xchg    eax,esi
        xchg    eax,edx
        aam
        xchg    al,ah
        or      ax,3030h
        stosw
        mov     eax,ecx
        or      eax,esi
        jnz     Asc64a

        inc     edi
        inc     edi
        cld
        cmp byte ptr [edi],30h       ;leading 0 ?
        jz      Asc64b               ;yes - supress it

        ret                          ;no - done

Asc64b: inc     edi
        ret

Asc64   ENDP


Asc642   PROC

;Convert 64-bit unsigned integer to ASCII decimal string
;
;Call With: EDX:EAX= QWORD value to convert
;
;  Returns: EDI= Offset into AscBuf of first numchar

        std
        mov     edi,offset AscBuf+18
        mov     ecx,edx
       ; xchg    eax,esi
        xor     eax,esi
		xor     esi,eax
		xor     eax,esi
        mov     ebx,100

Asc64a: xor     edx,edx
       ; xchg    eax,ecx
        xor     eax,ecx
		xor     ecx,eax
		xor     eax,ecx
        
        
        div     ebx
       ; xchg    eax,ecx
        xor     eax,ecx
		xor     ecx,eax
		xor     eax,ecx
		
        ;xchg    eax,esi
        xor     eax,esi
		xor     esi,eax
		xor     eax,esi
		
        div     ebx
        ;xchg    eax,esi
        xor     eax,esi
		xor     esi,eax
		xor     eax,esi
		
       ; xchg    eax,edx
        xor     eax,edx
		xor     edx,eax
		xor     eax,edx
		
        aam
        xchg    al,ah
        or      ax,3030h
        stosw
        mov     eax,ecx
        or      eax,esi
        jnz     Asc64a

        inc     edi
        inc     edi
        cld
        cmp byte ptr [edi],30h       ;leading 0 ?
        jz      Asc64b               ;yes - supress it

        ret                          ;no - done

Asc64b: inc     edi
        ret

Asc642   ENDP

dq2ascii proc uses ebx esi edi pqwValue,lpBuffer
LOCAL qtemp:QWORD

; The Svin

mov esi,pqwValue
mov edi,lpBuffer
mov edx,[esi]
mov eax,[esi+4]

cmp eax,0DE0B6B3h
jc  C1
jne C2
cmp edx,0A7640000h
jc  C1
C2:
cmp eax,8AC72304h
jc  D1
jne D2
cmp edx,89E80000h
jc  D1
D2:
mov byte ptr [edi],'1'
sub edx,89E80000h
lea edi,[edi+1]
sbb eax,8AC72304h

D1:
mov byte ptr [edi],'/'
@@:
inc byte ptr [edi]
sub edx,0A7640000h
sbb eax,0DE0B6B3h
jnc @B
add edx,0A7640000h
adc eax,0DE0B6B3h
inc edi

C1:
mov dword ptr [qtemp],edx
mov dword ptr [qtemp+4],eax

sub esp,10
fild QWORD ptr[qtemp]
fbstp TBYTE ptr[esp]
xor esi,esi
@@:
pop eax
bswap eax
mov ebx,eax  

mov ecx,eax
mov bl,bh

shr ecx,16
mov ah,al

shr bl,4
shr al,4

and bh,0fh
and ah,0fh

shl ebx,16
and eax,0FFFFh

mov edx,ecx
mov cl,ch

mov dh,dl
shr cl,4

shr dl,4
and ch,0fh

and dh,0fh
shl ecx,16

lea eax,[eax+ebx+30303030h]
lea edx,[edx+ecx+30303030h]

mov [edi+10],eax
mov [edi+14],edx
xor esi,1
lea edi,[edi-8]
jne @B

mov ah,[esp]
add edi,16
mov al,ah
add esp,2
shr  al,4
mov esi,[lpBuffer]
and eax,0f0fh
or eax,3030h
mov [edi],ax
cmp edi,esi
mov byte ptr[edi+18],0
jne P1
mov ecx,-20
add edi,19
@@:
inc ecx
cmp byte ptr[edi+ecx],30h
je @B
mov eax,ecx
js Z0
neg eax
add esi,eax
@@:
mov al,[edi+ecx]
mov [esi+ecx],al
inc ecx
jne @B

P1:
ret
Z0: 
mov byte ptr[esi+1],0
jmp P1
dq2ascii endp

;by ted
GetCPUName proc
    mov eax,80000000h
    cpuid
    .IF (eax>=80000005h)
        push edi
        lea edi,[buff]
        mov eax,80000002h
        cpuid
        mov [edi+00h],eax
        mov [edi+04h],ebx
        mov [edi+08h],ecx
        mov [edi+0Ch],edx
        mov eax,80000003h
        cpuid
        mov [edi+10h],eax
        mov [edi+14h],ebx
        mov [edi+18h],ecx
        mov [edi+1Ch],edx
        mov eax,80000004h
        cpuid
        mov [edi+20h],eax
        mov [edi+24h],ebx
        mov [edi+28h],ecx
        mov [edi+2Ch],edx
        mov eax,80000005h
        cpuid
        mov [edi+30h],eax
        mov [edi+34h],ebx
        mov [edi+38h],ecx
        mov [edi+3Ch],edx
        pop edi
    .ENDIF
	ret
GetCPUName endp
end start